# coding: utf-8

"""
    Robust Intelligence Firewall REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` header. Your AI Firewall Agent domain forms the base of the URL for REST API calls. To find the Agent domain in the Robust Intelligence UI, click AI Firewall: Settings icon: Firewall Settings. Find your agent in the Firewall Agent Status: Agents Setup page, and copy its URL from the table.

    The version of the OpenAPI document: 1.0
    Contact: dev@robustintelligence.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ri.fwclient.models.guardrail_ruleset_response import GuardrailRulesetResponse
from typing import Optional, Set
from typing_extensions import Self

class GuardrailScanResponse(BaseModel):
    """
    This conforms to the `GuardrailResponse` schema in AI Defense. protolint:disable MAX_LINE_LENGTH https://github.com/cisco-sbg/ai-firewall-services/blob/b5161bc8eb5a271d4cf5238d418d7ecbf1575c63/orchestrator/guardrails/types.go#L105-L111.
    """ # noqa: E501
    ruleset_types: Optional[List[GuardrailRulesetResponse]] = Field(default=None, description="List of responses for each ruleset evaluated.")
    telemetry_log_json: Optional[StrictStr] = Field(default=None, description="JSON string of the full detection report from RI guardrail.")
    __properties: ClassVar[List[str]] = ["ruleset_types", "telemetry_log_json"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GuardrailScanResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in ruleset_types (list)
        _items = []
        if self.ruleset_types:
            for _item in self.ruleset_types:
                if _item:
                    _items.append(_item.to_dict())
            _dict['ruleset_types'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GuardrailScanResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ruleset_types": [GuardrailRulesetResponse.from_dict(_item) for _item in obj["ruleset_types"]] if obj.get("ruleset_types") is not None else None,
            "telemetry_log_json": obj.get("telemetry_log_json")
        })
        return _obj


