# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `rime-api-key` header.

    The version of the OpenAPI document: 1.0
    Contact: dev@robustintelligence.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ObjectiveSubCategory(str, Enum):
    """
    ObjectiveSubCategory is the specific intent that the attack prompt is trying to achieve.   - OBJECTIVE_SUB_CATEGORY_FUNCTION_CALL_EXTRACTION: New categories as of July 2025 release at Cisco
    """

    """
    allowed enum values
    """
    OBJECTIVE_SUB_CATEGORY_THEFT = 'OBJECTIVE_SUB_CATEGORY_THEFT'
    OBJECTIVE_SUB_CATEGORY_POISONING = 'OBJECTIVE_SUB_CATEGORY_POISONING'
    OBJECTIVE_SUB_CATEGORY_STALKING = 'OBJECTIVE_SUB_CATEGORY_STALKING'
    OBJECTIVE_SUB_CATEGORY_TERRORISM = 'OBJECTIVE_SUB_CATEGORY_TERRORISM'
    OBJECTIVE_SUB_CATEGORY_BOMB = 'OBJECTIVE_SUB_CATEGORY_BOMB'
    OBJECTIVE_SUB_CATEGORY_MURDER = 'OBJECTIVE_SUB_CATEGORY_MURDER'
    OBJECTIVE_SUB_CATEGORY_PIRACY = 'OBJECTIVE_SUB_CATEGORY_PIRACY'
    OBJECTIVE_SUB_CATEGORY_VIRUS = 'OBJECTIVE_SUB_CATEGORY_VIRUS'
    OBJECTIVE_SUB_CATEGORY_MISINFORMATION = 'OBJECTIVE_SUB_CATEGORY_MISINFORMATION'
    OBJECTIVE_SUB_CATEGORY_FINANCIAL_ADVICE = 'OBJECTIVE_SUB_CATEGORY_FINANCIAL_ADVICE'
    OBJECTIVE_SUB_CATEGORY_PII = 'OBJECTIVE_SUB_CATEGORY_PII'
    OBJECTIVE_SUB_CATEGORY_PROMPT_EXTRACTION = 'OBJECTIVE_SUB_CATEGORY_PROMPT_EXTRACTION'
    OBJECTIVE_SUB_CATEGORY_COPYRIGHT_EXTRACTION = 'OBJECTIVE_SUB_CATEGORY_COPYRIGHT_EXTRACTION'
    OBJECTIVE_SUB_CATEGORY_DRUGS = 'OBJECTIVE_SUB_CATEGORY_DRUGS'
    OBJECTIVE_SUB_CATEGORY_SUICIDE = 'OBJECTIVE_SUB_CATEGORY_SUICIDE'
    OBJECTIVE_SUB_CATEGORY_ANIMAL_VIOLENCE = 'OBJECTIVE_SUB_CATEGORY_ANIMAL_VIOLENCE'
    OBJECTIVE_SUB_CATEGORY_BRANDED_CONTENT = 'OBJECTIVE_SUB_CATEGORY_BRANDED_CONTENT'
    OBJECTIVE_SUB_CATEGORY_BULLYING = 'OBJECTIVE_SUB_CATEGORY_BULLYING'
    OBJECTIVE_SUB_CATEGORY_CELEBRITY_PII = 'OBJECTIVE_SUB_CATEGORY_CELEBRITY_PII'
    OBJECTIVE_SUB_CATEGORY_CHEATING = 'OBJECTIVE_SUB_CATEGORY_CHEATING'
    OBJECTIVE_SUB_CATEGORY_CHILD_SEXUAL_ABUSE_MATERIAL = 'OBJECTIVE_SUB_CATEGORY_CHILD_SEXUAL_ABUSE_MATERIAL'
    OBJECTIVE_SUB_CATEGORY_DISABILITIES = 'OBJECTIVE_SUB_CATEGORY_DISABILITIES'
    OBJECTIVE_SUB_CATEGORY_ECONOMIC_CLASS = 'OBJECTIVE_SUB_CATEGORY_ECONOMIC_CLASS'
    OBJECTIVE_SUB_CATEGORY_EMOTIONAL_ABUSE = 'OBJECTIVE_SUB_CATEGORY_EMOTIONAL_ABUSE'
    OBJECTIVE_SUB_CATEGORY_FIREARMS = 'OBJECTIVE_SUB_CATEGORY_FIREARMS'
    OBJECTIVE_SUB_CATEGORY_HUMAN_EXPLOITATION = 'OBJECTIVE_SUB_CATEGORY_HUMAN_EXPLOITATION'
    OBJECTIVE_SUB_CATEGORY_IMMIGRATION_STATUS = 'OBJECTIVE_SUB_CATEGORY_IMMIGRATION_STATUS'
    OBJECTIVE_SUB_CATEGORY_IMPERSONATION_IMPOSTOR_CONTENT = 'OBJECTIVE_SUB_CATEGORY_IMPERSONATION_IMPOSTOR_CONTENT'
    OBJECTIVE_SUB_CATEGORY_INTELLECTUAL_PROPERTY_PIRACY = 'OBJECTIVE_SUB_CATEGORY_INTELLECTUAL_PROPERTY_PIRACY'
    OBJECTIVE_SUB_CATEGORY_LOGOS = 'OBJECTIVE_SUB_CATEGORY_LOGOS'
    OBJECTIVE_SUB_CATEGORY_MARITAL_STATUS = 'OBJECTIVE_SUB_CATEGORY_MARITAL_STATUS'
    OBJECTIVE_SUB_CATEGORY_MOVIE_QUOTES = 'OBJECTIVE_SUB_CATEGORY_MOVIE_QUOTES'
    OBJECTIVE_SUB_CATEGORY_PERSONAL_IDENTIFICATION_NUMBERS = 'OBJECTIVE_SUB_CATEGORY_PERSONAL_IDENTIFICATION_NUMBERS'
    OBJECTIVE_SUB_CATEGORY_PHISHING = 'OBJECTIVE_SUB_CATEGORY_PHISHING'
    OBJECTIVE_SUB_CATEGORY_PLAGIARISM = 'OBJECTIVE_SUB_CATEGORY_PLAGIARISM'
    OBJECTIVE_SUB_CATEGORY_PORNOGRAPHIC_DEPICTIONS = 'OBJECTIVE_SUB_CATEGORY_PORNOGRAPHIC_DEPICTIONS'
    OBJECTIVE_SUB_CATEGORY_RELIGIOUS_BELIEFS = 'OBJECTIVE_SUB_CATEGORY_RELIGIOUS_BELIEFS'
    OBJECTIVE_SUB_CATEGORY_RISKY_FINANCIAL_PRACTICES = 'OBJECTIVE_SUB_CATEGORY_RISKY_FINANCIAL_PRACTICES'
    OBJECTIVE_SUB_CATEGORY_RISKY_PRANKS = 'OBJECTIVE_SUB_CATEGORY_RISKY_PRANKS'
    OBJECTIVE_SUB_CATEGORY_SCAMS = 'OBJECTIVE_SUB_CATEGORY_SCAMS'
    OBJECTIVE_SUB_CATEGORY_SONG_LYRICS = 'OBJECTIVE_SUB_CATEGORY_SONG_LYRICS'
    OBJECTIVE_SUB_CATEGORY_SPAM = 'OBJECTIVE_SUB_CATEGORY_SPAM'
    OBJECTIVE_SUB_CATEGORY_SURVEILLANCE = 'OBJECTIVE_SUB_CATEGORY_SURVEILLANCE'
    OBJECTIVE_SUB_CATEGORY_SYSTEMIC_RACISM = 'OBJECTIVE_SUB_CATEGORY_SYSTEMIC_RACISM'
    OBJECTIVE_SUB_CATEGORY_THREATS_AND_INTIMIDATION = 'OBJECTIVE_SUB_CATEGORY_THREATS_AND_INTIMIDATION'
    OBJECTIVE_SUB_CATEGORY_TOXIC_CHEMICALS = 'OBJECTIVE_SUB_CATEGORY_TOXIC_CHEMICALS'
    OBJECTIVE_SUB_CATEGORY_UNSAFE_HEALTH_PRACTICES = 'OBJECTIVE_SUB_CATEGORY_UNSAFE_HEALTH_PRACTICES'
    OBJECTIVE_SUB_CATEGORY_WAR_CRIMES = 'OBJECTIVE_SUB_CATEGORY_WAR_CRIMES'
    OBJECTIVE_SUB_CATEGORY_WORKPLACE_DISCRIMINATION = 'OBJECTIVE_SUB_CATEGORY_WORKPLACE_DISCRIMINATION'
    OBJECTIVE_SUB_CATEGORY_FUNCTION_CALL_EXTRACTION = 'OBJECTIVE_SUB_CATEGORY_FUNCTION_CALL_EXTRACTION'
    OBJECTIVE_SUB_CATEGORY_MALWARE_VIRUS = 'OBJECTIVE_SUB_CATEGORY_MALWARE_VIRUS'
    OBJECTIVE_SUB_CATEGORY_VULN_EXPLOIT = 'OBJECTIVE_SUB_CATEGORY_VULN_EXPLOIT'
    OBJECTIVE_SUB_CATEGORY_RANSOMWARE_OPS = 'OBJECTIVE_SUB_CATEGORY_RANSOMWARE_OPS'
    OBJECTIVE_SUB_CATEGORY_NETWORK_ATTACK_OPS = 'OBJECTIVE_SUB_CATEGORY_NETWORK_ATTACK_OPS'
    OBJECTIVE_SUB_CATEGORY_SOCIAL_ENGG = 'OBJECTIVE_SUB_CATEGORY_SOCIAL_ENGG'
    OBJECTIVE_SUB_CATEGORY_MALICIOUS_INFRA_OPS = 'OBJECTIVE_SUB_CATEGORY_MALICIOUS_INFRA_OPS'
    OBJECTIVE_SUB_CATEGORY_COMPROMISED_ASSET_TRADE = 'OBJECTIVE_SUB_CATEGORY_COMPROMISED_ASSET_TRADE'
    OBJECTIVE_SUB_CATEGORY_NUCLEAR_THREAT = 'OBJECTIVE_SUB_CATEGORY_NUCLEAR_THREAT'
    OBJECTIVE_SUB_CATEGORY_BIO_WEAPON = 'OBJECTIVE_SUB_CATEGORY_BIO_WEAPON'
    OBJECTIVE_SUB_CATEGORY_DOMESTIC_ABUSE = 'OBJECTIVE_SUB_CATEGORY_DOMESTIC_ABUSE'
    OBJECTIVE_SUB_CATEGORY_TORTURE_METHODS = 'OBJECTIVE_SUB_CATEGORY_TORTURE_METHODS'
    OBJECTIVE_SUB_CATEGORY_BOMB_THREATS = 'OBJECTIVE_SUB_CATEGORY_BOMB_THREATS'
    OBJECTIVE_SUB_CATEGORY_VIOLENCE_OR_ASSAULT = 'OBJECTIVE_SUB_CATEGORY_VIOLENCE_OR_ASSAULT'
    OBJECTIVE_SUB_CATEGORY_VIOLENT_REVOLT = 'OBJECTIVE_SUB_CATEGORY_VIOLENT_REVOLT'
    OBJECTIVE_SUB_CATEGORY_MASS_ATTACK = 'OBJECTIVE_SUB_CATEGORY_MASS_ATTACK'
    OBJECTIVE_SUB_CATEGORY_FIREARMS_WEAPONS_MAKING = 'OBJECTIVE_SUB_CATEGORY_FIREARMS_WEAPONS_MAKING'
    OBJECTIVE_SUB_CATEGORY_FIREARMS_WEAPONS_GENERIC = 'OBJECTIVE_SUB_CATEGORY_FIREARMS_WEAPONS_GENERIC'
    OBJECTIVE_SUB_CATEGORY_SWATTING_ATTACK = 'OBJECTIVE_SUB_CATEGORY_SWATTING_ATTACK'
    OBJECTIVE_SUB_CATEGORY_ANIMAL_ABUSE = 'OBJECTIVE_SUB_CATEGORY_ANIMAL_ABUSE'
    OBJECTIVE_SUB_CATEGORY_RACISM = 'OBJECTIVE_SUB_CATEGORY_RACISM'
    OBJECTIVE_SUB_CATEGORY_HATE_SPEECH = 'OBJECTIVE_SUB_CATEGORY_HATE_SPEECH'
    OBJECTIVE_SUB_CATEGORY_RELIGIOUS_BIAS = 'OBJECTIVE_SUB_CATEGORY_RELIGIOUS_BIAS'
    OBJECTIVE_SUB_CATEGORY_ECONOMY_CLASS_BIAS = 'OBJECTIVE_SUB_CATEGORY_ECONOMY_CLASS_BIAS'
    OBJECTIVE_SUB_CATEGORY_DISABILITY_BIAS = 'OBJECTIVE_SUB_CATEGORY_DISABILITY_BIAS'
    OBJECTIVE_SUB_CATEGORY_WORKPLACE_BIAS = 'OBJECTIVE_SUB_CATEGORY_WORKPLACE_BIAS'
    OBJECTIVE_SUB_CATEGORY_THREATS_INTIMIDATION = 'OBJECTIVE_SUB_CATEGORY_THREATS_INTIMIDATION'
    OBJECTIVE_SUB_CATEGORY_HUMAN_EXPLOIT = 'OBJECTIVE_SUB_CATEGORY_HUMAN_EXPLOIT'
    OBJECTIVE_SUB_CATEGORY_CYBERBULLYING = 'OBJECTIVE_SUB_CATEGORY_CYBERBULLYING'
    OBJECTIVE_SUB_CATEGORY_SOCIAL_MEDIA_HARASSMENT = 'OBJECTIVE_SUB_CATEGORY_SOCIAL_MEDIA_HARASSMENT'
    OBJECTIVE_SUB_CATEGORY_SEXUAL_CONTENT = 'OBJECTIVE_SUB_CATEGORY_SEXUAL_CONTENT'
    OBJECTIVE_SUB_CATEGORY_SEXUAL_HARASSMENT = 'OBJECTIVE_SUB_CATEGORY_SEXUAL_HARASSMENT'
    OBJECTIVE_SUB_CATEGORY_CHILD_SEX_ABUSE = 'OBJECTIVE_SUB_CATEGORY_CHILD_SEX_ABUSE'
    OBJECTIVE_SUB_CATEGORY_SEXUAL_ABUSE = 'OBJECTIVE_SUB_CATEGORY_SEXUAL_ABUSE'
    OBJECTIVE_SUB_CATEGORY_SEXTORTION = 'OBJECTIVE_SUB_CATEGORY_SEXTORTION'
    OBJECTIVE_SUB_CATEGORY_SEXUAL_ROLEPLAY = 'OBJECTIVE_SUB_CATEGORY_SEXUAL_ROLEPLAY'
    OBJECTIVE_SUB_CATEGORY_SEXUAL_SERVICES = 'OBJECTIVE_SUB_CATEGORY_SEXUAL_SERVICES'
    OBJECTIVE_SUB_CATEGORY_SEXUAL_VULGARITY = 'OBJECTIVE_SUB_CATEGORY_SEXUAL_VULGARITY'
    OBJECTIVE_SUB_CATEGORY_GENERAL_VULGARITY = 'OBJECTIVE_SUB_CATEGORY_GENERAL_VULGARITY'
    OBJECTIVE_SUB_CATEGORY_VIOLENT_PROFANITY = 'OBJECTIVE_SUB_CATEGORY_VIOLENT_PROFANITY'
    OBJECTIVE_SUB_CATEGORY_CODED_PROFANITY = 'OBJECTIVE_SUB_CATEGORY_CODED_PROFANITY'
    OBJECTIVE_SUB_CATEGORY_ORGAN_TRAFFICKING = 'OBJECTIVE_SUB_CATEGORY_ORGAN_TRAFFICKING'
    OBJECTIVE_SUB_CATEGORY_GOLD_TRAFFICKING = 'OBJECTIVE_SUB_CATEGORY_GOLD_TRAFFICKING'
    OBJECTIVE_SUB_CATEGORY_SMUGGLING = 'OBJECTIVE_SUB_CATEGORY_SMUGGLING'
    OBJECTIVE_SUB_CATEGORY_WEAPONS_TRAFFICKING = 'OBJECTIVE_SUB_CATEGORY_WEAPONS_TRAFFICKING'
    OBJECTIVE_SUB_CATEGORY_BANK_FRAUD = 'OBJECTIVE_SUB_CATEGORY_BANK_FRAUD'
    OBJECTIVE_SUB_CATEGORY_INVESTMENT_FRAUD = 'OBJECTIVE_SUB_CATEGORY_INVESTMENT_FRAUD'
    OBJECTIVE_SUB_CATEGORY_CRYPTO_FRAUD = 'OBJECTIVE_SUB_CATEGORY_CRYPTO_FRAUD'
    OBJECTIVE_SUB_CATEGORY_FINANCIAL_SCAM = 'OBJECTIVE_SUB_CATEGORY_FINANCIAL_SCAM'
    OBJECTIVE_SUB_CATEGORY_ILLICIT_FINANCIAL_ADVICE = 'OBJECTIVE_SUB_CATEGORY_ILLICIT_FINANCIAL_ADVICE'
    OBJECTIVE_SUB_CATEGORY_IMMIGRATION_ABUSE = 'OBJECTIVE_SUB_CATEGORY_IMMIGRATION_ABUSE'
    OBJECTIVE_SUB_CATEGORY_IMMIGRATION_SCAM = 'OBJECTIVE_SUB_CATEGORY_IMMIGRATION_SCAM'
    OBJECTIVE_SUB_CATEGORY_LAND_EXPLOITATION = 'OBJECTIVE_SUB_CATEGORY_LAND_EXPLOITATION'
    OBJECTIVE_SUB_CATEGORY_FOREST_EXPLOITATION = 'OBJECTIVE_SUB_CATEGORY_FOREST_EXPLOITATION'
    OBJECTIVE_SUB_CATEGORY_WATER_EXPLOITATION = 'OBJECTIVE_SUB_CATEGORY_WATER_EXPLOITATION'
    OBJECTIVE_SUB_CATEGORY_POLLUTION_GENERIC = 'OBJECTIVE_SUB_CATEGORY_POLLUTION_GENERIC'
    OBJECTIVE_SUB_CATEGORY_ECOSYSTEM_DISRUPTION = 'OBJECTIVE_SUB_CATEGORY_ECOSYSTEM_DISRUPTION'
    OBJECTIVE_SUB_CATEGORY_TECH_SUPPORT_SCAM = 'OBJECTIVE_SUB_CATEGORY_TECH_SUPPORT_SCAM'
    OBJECTIVE_SUB_CATEGORY_DIGITAL_SPAM = 'OBJECTIVE_SUB_CATEGORY_DIGITAL_SPAM'
    OBJECTIVE_SUB_CATEGORY_PROPRIETARY_CODE_ABUSE = 'OBJECTIVE_SUB_CATEGORY_PROPRIETARY_CODE_ABUSE'
    OBJECTIVE_SUB_CATEGORY_REVERSE_ENGINEERING_CODE = 'OBJECTIVE_SUB_CATEGORY_REVERSE_ENGINEERING_CODE'
    OBJECTIVE_SUB_CATEGORY_LICENSE_BYPASS_SPOOFING = 'OBJECTIVE_SUB_CATEGORY_LICENSE_BYPASS_SPOOFING'
    OBJECTIVE_SUB_CATEGORY_COUNTERFEITING = 'OBJECTIVE_SUB_CATEGORY_COUNTERFEITING'
    OBJECTIVE_SUB_CATEGORY_FAKE_SERVICES = 'OBJECTIVE_SUB_CATEGORY_FAKE_SERVICES'
    OBJECTIVE_SUB_CATEGORY_FOOD_FRAUD = 'OBJECTIVE_SUB_CATEGORY_FOOD_FRAUD'
    OBJECTIVE_SUB_CATEGORY_CHEATING_OR_PLAGIARISM = 'OBJECTIVE_SUB_CATEGORY_CHEATING_OR_PLAGIARISM'
    OBJECTIVE_SUB_CATEGORY_EVIDENCE_TAMPERING = 'OBJECTIVE_SUB_CATEGORY_EVIDENCE_TAMPERING'
    OBJECTIVE_SUB_CATEGORY_TERROR_PROPAGANDA = 'OBJECTIVE_SUB_CATEGORY_TERROR_PROPAGANDA'
    OBJECTIVE_SUB_CATEGORY_TERROR_GROUP = 'OBJECTIVE_SUB_CATEGORY_TERROR_GROUP'
    OBJECTIVE_SUB_CATEGORY_TERROR_ACTIONS = 'OBJECTIVE_SUB_CATEGORY_TERROR_ACTIONS'
    OBJECTIVE_SUB_CATEGORY_MODEL_INFORMATION_EXTRACTION = 'OBJECTIVE_SUB_CATEGORY_MODEL_INFORMATION_EXTRACTION'
    OBJECTIVE_SUB_CATEGORY_DISINFORMATION = 'OBJECTIVE_SUB_CATEGORY_DISINFORMATION'
    OBJECTIVE_SUB_CATEGORY_IMPERSONATION_IMPOSTER_CONTENT = 'OBJECTIVE_SUB_CATEGORY_IMPERSONATION_IMPOSTER_CONTENT'
    OBJECTIVE_SUB_CATEGORY_SUICIDE_METHODS = 'OBJECTIVE_SUB_CATEGORY_SUICIDE_METHODS'
    OBJECTIVE_SUB_CATEGORY_SUICIDE_ENCOURAGE = 'OBJECTIVE_SUB_CATEGORY_SUICIDE_ENCOURAGE'
    OBJECTIVE_SUB_CATEGORY_SELFHARM_TECHNIQUE = 'OBJECTIVE_SUB_CATEGORY_SELFHARM_TECHNIQUE'
    OBJECTIVE_SUB_CATEGORY_SUICIDE_PACT = 'OBJECTIVE_SUB_CATEGORY_SUICIDE_PACT'
    OBJECTIVE_SUB_CATEGORY_SUICIDE_NOTE = 'OBJECTIVE_SUB_CATEGORY_SUICIDE_NOTE'
    OBJECTIVE_SUB_CATEGORY_COPYRIGHT_CONTENT = 'OBJECTIVE_SUB_CATEGORY_COPYRIGHT_CONTENT'
    OBJECTIVE_SUB_CATEGORY_SONGS_PIRACY_AND_INFRINGEMENT = 'OBJECTIVE_SUB_CATEGORY_SONGS_PIRACY_AND_INFRINGEMENT'
    OBJECTIVE_SUB_CATEGORY_MOVIES_PIRACY_AND_INFRINGEMENT = 'OBJECTIVE_SUB_CATEGORY_MOVIES_PIRACY_AND_INFRINGEMENT'
    OBJECTIVE_SUB_CATEGORY_TV_CONTENT_PIRACY_AND_INFRINGEMENT = 'OBJECTIVE_SUB_CATEGORY_TV_CONTENT_PIRACY_AND_INFRINGEMENT'
    OBJECTIVE_SUB_CATEGORY_LITERATURE_PIRACY_AND_INFRINGEMENT = 'OBJECTIVE_SUB_CATEGORY_LITERATURE_PIRACY_AND_INFRINGEMENT'
    OBJECTIVE_SUB_CATEGORY_UNSAFE_ACTIONS = 'OBJECTIVE_SUB_CATEGORY_UNSAFE_ACTIONS'
    OBJECTIVE_SUB_CATEGORY_DANGEROUS_GAMES = 'OBJECTIVE_SUB_CATEGORY_DANGEROUS_GAMES'
    OBJECTIVE_SUB_CATEGORY_UNSAFE_MEDS_ADVICE = 'OBJECTIVE_SUB_CATEGORY_UNSAFE_MEDS_ADVICE'
    OBJECTIVE_SUB_CATEGORY_UNSAFE_MEDICAL_PROCEDURES = 'OBJECTIVE_SUB_CATEGORY_UNSAFE_MEDICAL_PROCEDURES'
    OBJECTIVE_SUB_CATEGORY_ILLEGAL_REPRODUCTIVE_PRACTICES = 'OBJECTIVE_SUB_CATEGORY_ILLEGAL_REPRODUCTIVE_PRACTICES'
    OBJECTIVE_SUB_CATEGORY_PERSONAL_IDENTIFICATION_NUMBER = 'OBJECTIVE_SUB_CATEGORY_PERSONAL_IDENTIFICATION_NUMBER'
    OBJECTIVE_SUB_CATEGORY_TARGETED_PERSON_PII = 'OBJECTIVE_SUB_CATEGORY_TARGETED_PERSON_PII'
    OBJECTIVE_SUB_CATEGORY_HACKING = 'OBJECTIVE_SUB_CATEGORY_HACKING'
    OBJECTIVE_SUB_CATEGORY_UNSPECIFIED = 'OBJECTIVE_SUB_CATEGORY_UNSPECIFIED'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ObjectiveSubCategory from a JSON string"""
        return cls(json.loads(json_str))


